#define _CRT_SECURE_NO_WARNINGS

#include <Windows.h>
#include <stdio.h>
#include "QuadEq.h"

#define FILE_OUT "C:\\Users\\\\source\\repos\\TaskSystem\\x64\\Debug\\result.txt"

QuadraticEquation* readFile(char* nameFile)
{
	QuadraticEquation* equation = malloc(sizeof(QuadraticEquation));
	FILE* file = fopen(nameFile, "r");
	if (file == NULL)
	{
		printf("     .   %s \n", nameFile);
		exit(ERROR_OPEN_FILE);
	}
	int resultRead = fscanf(file, "%lf %lf %lf", &equation->a, &equation->b, &equation->c);

	if (resultRead == 0)
	{
		printf("    .\n");
		exit(ERROR_READ_DATA);
	}
	if (equation->a == 0 && equation->b == 0 && equation->c == 0)
	{
		printf("   0.   .\n");
		exit(ERROR_READ_DATA);
	}
	if (equation->a == 0)
	{
		printf("   0.    .\n");
		exit(ERROR_READ_DATA);
	}
	fclose(file);
	return equation;
}

int startWorkWithProcess()
{
	QuadraticEquation* myEq = readFile(FILE_IN);
	LPSTR inputKoef = calloc(BUFFER, sizeof(char));
	sprintf(inputKoef, "%lf %lf %lf\0", myEq->a, myEq->b, myEq->c);
	/*
	*      :
	* childName -    
	* commandLine -        
	* si -   
	* pi - ,   
	*/

	LPCSTR childName = "C:\\Users\\\\source\\repos\\TaskSystem\\x64\\Debug\\ChildProcess.exe";

	//LPCSTR childName = "ChildProcess.exe";
	LPSTR commandLine = inputKoef;
	STARTUPINFO si;
	/*    */
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	PROCESS_INFORMATION pi;
	ZeroMemory(&pi, sizeof(pi));

	//TRUE / FALSE    .       .
	if (!CreateProcessA(childName, commandLine, NULL, NULL, FALSE, NULL, NULL, NULL, &si, &pi))
	{
		printf("   .  : %d.\n", GetLastError());
	}

	//    
	WaitForSingleObject(pi.hProcess, INFINITE);
	DWORD childexitcode;
	GetExitCodeProcess(pi.hProcess, &childexitcode);
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
	printf("    %d\n", childexitcode);
	if (childexitcode >= 0 && childexitcode <= 2)
	{
		FILE* resFile = fopen(FILE_OUT, "r");
		if (resFile == NULL)
		{
			printf("-        \n");
			exit(-1);
		}
		while (!feof(resFile))
		{
			char* str = calloc(BUFFER, sizeof(char));
			fgets(str, BUFFER, resFile);
			printf("%s", str);
		}
	}
	else
	{
		printf("-      \n");
		exit(-1);
	}
	system("pause");
	return 0;
}