#include "Header.h"

/// <summary>
/// ,    
/// </summary>
struct ElementList
{
	int value;
	struct ElementList* nextElement;
};

typedef struct ElementList ElementList; //  
typedef ElementList* List; //    ( )

/// <summary>
///    .
/// </summary>
/// <param name="length">-  .</param>
/// <returns>   .</returns>
List createIntList(int length)
{
	if (!length)
		return 1;
	List headOfList = calloc(1, sizeof(ElementList));
	headOfList->value = 1;
	headOfList->nextElement = NULL;
	List currentElement = headOfList, newElement;
	for (int i = 2; i <= length; i++)
	{
		newElement = calloc(1, sizeof(ElementList));
		newElement->value = i;
		currentElement->nextElement = newElement;
		currentElement = newElement;
	}
	currentElement->nextElement = NULL;
	return headOfList;
}

/// <summary>
///    .
/// </summary>
/// <param name="list">   .</param>
void deleteIntList(List list)
{
	while (list)
	{
		List nextList = list->nextElement;
		free(list);
		list = nextList;
	}
	free(list);
}

/// <summary>
///      .
/// </summary>
/// <param name="list">   .</param>
void printIntList(List list)
{
	while (list)
	{
		printf("%d ", list->value);
		list = list->nextElement;
	}
	printf("\n");
}

/// <summary>
///      .
/// </summary>
/// <param name="list">   .</param>
/// <param name="numberElemnt">  .</param>
/// <param name="insertedElement"> .</param>
/// <returns>    .</returns>
List insertIntElementInList(List list, int numberElemnt, List insertedElement)
{
	List headOfList = list;
	if (numberElemnt > 1)
	{
		for (int i = 1; i < numberElemnt - 1; i++)
		{
			list = list->nextElement;
		}
		insertedElement->nextElement = list->nextElement;
		list->nextElement = insertedElement;
	}
	else if (numberElemnt == 1)
	{
		insertedElement->nextElement = list;
		headOfList = insertedElement;
	}
	return headOfList;
}

/// <summary>
///     .
/// </summary>
/// <param name="list">   .</param>
/// <param name="numberElemnt">   .</param>
/// <returns>    .</returns>
List deletIntElementInList(List list, int numberElemnt)
{
	List headOfList = list;
	if (numberElemnt > 1)
	{
		for (int i = 1; i < numberElemnt - 1; i++)
		{
			list = list->nextElement;
		}
		list->nextElement = list->nextElement->nextElement;
	}
	else if (numberElemnt == 1)
	{
		headOfList = list->nextElement;
		free(list);
	}
	return headOfList;
}

/// <summary>
///      .
/// </summary>
/// <param name="list">   .</param>
/// <param name="numberFirstElement">  .</param>
/// <param name="numberSecondElement">  .</param>
/// <returns>    .</returns>
List swapElementIntList(List list, int numberFirstElement, int numberSecondElement)
{
	List headOfList = list;
	//   
	if (numberFirstElement == numberSecondElement)
	{
		return headOfList;
	}
	//  ,    
	if (numberFirstElement > numberSecondElement)
	{
		int temp = numberFirstElement;
		numberFirstElement = numberSecondElement;
		numberSecondElement = temp;
	}
	//    
	if (numberFirstElement == 1)
	{
		for (int i = 1; i < numberSecondElement - 1; i++)
		{
			list = list->nextElement;
		}
		List currentElement = list->nextElement;
		List nextAfterCurrentElement = currentElement->nextElement;
		currentElement->nextElement = headOfList->nextElement;
		list->nextElement = headOfList;
		headOfList->nextElement = nextAfterCurrentElement;
		return currentElement;
	}
	//  swap'
	else
	{
		for (int i = 1; i < numberFirstElement - 1; i++)
		{
			list = list->nextElement;
		}
		List prefFirstCurrentElement = list; //    
		for (int i = numberFirstElement - 1; i < numberSecondElement - 1; i++)
		{
			list = list->nextElement;
		}
		List prefSecondCurrentElement = list;  //    
		List nextFirstCurrentElemnt = prefFirstCurrentElement->nextElement->nextElement; // -    
		prefFirstCurrentElement->nextElement->nextElement = prefSecondCurrentElement->nextElement->nextElement;
		prefSecondCurrentElement->nextElement->nextElement = nextFirstCurrentElemnt;
		List firstCurrentElemnt = prefFirstCurrentElement->nextElement; // -    
		prefFirstCurrentElement->nextElement = prefSecondCurrentElement->nextElement;
		prefSecondCurrentElement->nextElement = firstCurrentElemnt;
		return headOfList;
	}
}

int startWorkWithLinelist()
{
	
	// 
	List MyList = createIntList(10);
	printIntList(MyList);

	// 
	List newElemnt = calloc(1, sizeof(ElementList));
	newElemnt->value = 99;
	MyList = insertIntElementInList(MyList, 1, newElemnt);

	printIntList(MyList);

	// 
	MyList = deletIntElementInList(MyList, 1);
	printIntList(MyList);

	//  
	MyList = swapElementIntList(MyList, 10, 1);
	printIntList(MyList);

	// 
	deleteIntList(MyList);
	return 0;
}