#include "Header.h"
#define S_BUFFER 128

struct Time
{
	unsigned int hour;
	unsigned int minute;
	unsigned int second;
};
typedef struct Time Time;

DWORD WINAPI thShowTime(LPVOID param);

void PassTime(Time* time);
DWORD WINAPI WorkClock();
DWORD WINAPI WorkTimer(LPVOID param);
DWORD WINAPI WorkStopwatch(LPVOID param);
void Pause(HANDLE hThread);
VOID SettingClock(Time* clock);

DWORD idShowThread = 0;
HANDLE hThreadShow;

BOOL showClockWork = 1;
HANDLE hThreadShowClock;
HANDLE hActivityThread;

int startWorkWithClock()
{
	Time* clock = calloc(1, sizeof(Time));
	Time* timer = calloc(1, sizeof(Time));
	Time* stopwatch = calloc(1, sizeof(Time));
	puts(" :");
	puts("1.   ");
	puts("2.  .   .");
	puts("3.  /  ");
	puts("4.  /  ");
	puts("5.    /   ");
	//puts("6. ");
	puts("0. ");
	puts("\n");


	HANDLE hThread[3];
	hThread[0] = CreateThread(NULL, 0, WorkClock, clock, NULL, NULL);
	hThread[1] = NULL;
	hThread[2] = NULL;
	showClockWork = 1;
	hThreadShowClock = CreateThread(NULL, 0, thShowTime, clock, NULL, NULL);

	//int countPause;
	//countPause = SuspendThread(hThread[0]);
	//countPause = SuspendThread(hThread[0]);
	//if (countPause = SuspendThread(hThread[0]) > 0)
	//{
	//	//puts(" .");
	//	while (countPause != -1)
	//	{
	//		ResumeThread(hThread);
	//		countPause--;
	//	}
	//	return;
	//}
	
	int setClock = 0;
	int setTimer = 0;
	int setStopwatch = 0;

	for (;;)
	{
		char* numActivity = calloc(S_BUFFER, sizeof(char));
		int iNumActivity;
		while (gets_s(numActivity, S_BUFFER) == NULL)
		{
			puts("-   !");
		}
		
		sscanf(numActivity, "%d", &iNumActivity);
		switch (iNumActivity)
		{
		case 1:;
			if (hThread[0] == NULL)
			{
				hThread[0] = CreateThread(NULL, 0, WorkClock, clock, NULL, NULL);
				hThreadShowClock = CreateThread(NULL, 0, thShowTime, clock, NULL, NULL);
			}
			if (!showClockWork)
			{
				showClockWork = 1;
				Pause(hThreadShowClock);
			}
			break;
		
		case 2:
			if (setClock == 0)
			{
				puts("");
				if (showClockWork)
				{
					showClockWork = 0;
					Pause(hThreadShowClock);
				}
				setClock = 1;
				if (hThread[0] != NULL)
				{
					TerminateThread(hThread[0], 0);
					if (idShowThread != 0)
					{
						Pause(hThreadShow);
					}
				}
				SettingClock(clock);
				hThread[0] = CreateThread(NULL, 0, WorkClock, clock, NULL, NULL);
				if (!showClockWork)
				{
					showClockWork = 1;
					Pause(hThreadShowClock);
				}
				setClock = 0;
			}
			break;
		case 3:
			if (setTimer == 0)
			{
				puts("");

				setTimer = 1;
				if (showClockWork)
				{
					showClockWork = 0;
					Pause(hThreadShowClock);
				}
				if (hThread[1] != NULL)
				{
					TerminateThread(hThread[1], 0);
				}
				if (hActivityThread != hThread[1] && hActivityThread != NULL)
				{
					TerminateThread(hThreadShow, 0);
				}
				puts("    .");
				SettingClock(timer);
				hThread[1] = CreateThread(NULL, 0, WorkTimer, timer, NULL, NULL);
				hActivityThread = hThread[1];
				setTimer = 0;
			}
			break;
		case 4:

			if (setStopwatch == 0)
			{
				puts(" ");

				setStopwatch = 1;
				if (showClockWork)
				{
					showClockWork = 0;
					Pause(hThreadShowClock);
				}
				if (hThread[2] != NULL )
				{
					TerminateThread(hThread[2], 0);
				}
				if (hActivityThread != hThread[2] && hActivityThread != NULL)
				{
					TerminateThread(hThreadShow, 0);
				}
				
				hThread[2] = CreateThread(NULL, 0, WorkStopwatch, stopwatch, NULL, NULL);
				hActivityThread = hThread[2];
			}
			else if(setStopwatch == 1)
			{
				puts(" ");
				char* stringTime = malloc(sizeof(char) * 9);
				sprintf(stringTime, " : %02d:%02d:%02d\0", stopwatch->hour, stopwatch->minute, stopwatch->second);
				puts(stringTime);

				TerminateThread(hThread[2], 0);
				free(stopwatch);
				stopwatch = calloc(1, sizeof(Time));
				TerminateThread(hThreadShow, 0);
				idShowThread = 0;
				setStopwatch = 0;
			}
			break;

		case 5:
				Pause(hActivityThread);
				break;
		case 0:
			puts("");
			return 0;
		default:
			break;
		}

	}
	WaitForMultipleObjects(3, hThread, TRUE, INFINITE);
	puts(" ");
	return 0;
}


DWORD WINAPI thShowTime(LPVOID param)
{
	if (idShowThread != 0)
	{
		TerminateProcess(hThreadShow, 0);
	}
	Time* time = (Time*)param;
	Time* changeTime = malloc(sizeof(Time));
	changeTime->hour = time->hour;
	changeTime->minute = time->minute;
	changeTime->second = time->second;
	char* stringTime = malloc(sizeof(char) * 9);
	sprintf(stringTime, "%02d:%02d:%02d\0", time->hour, time->minute, time->second);
	puts(stringTime);
	for (;;)
	{
		if (changeTime->hour != time->hour || changeTime->minute != time->minute || changeTime->second != time->second)
		{
			sprintf(stringTime, "%02d:%02d:%02d\0", time->hour, time->minute, time->second);
			puts(stringTime);
			changeTime->hour = time->hour;
			changeTime->minute = time->minute;
			changeTime->second = time->second;
		}		
	}
	ExitThread(0);
}

void PassTime(Time* time)
{
	while (1)
	{
		Sleep(1000); //  
		time->second++;
		if (time->second == 60)
		{
			time->second = 0;
			time->minute++;
		}
		if (time->minute == 60)
		{
			time->minute = 0;
			time->hour++;
		}
		if (time->hour == 24)
		{
			time->hour = 0;
		}
	}
}

/// <summary>
///    .
/// </summary>
/// <param name="param">  .</param>
/// <returns>.</returns>
DWORD WINAPI WorkClock(LPVOID param)
{
	if (idShowThread != 0)
	{
		TerminateProcess(hThreadShow, 0);
	}
	Time* clock = (Time*)param;
	PassTime(clock);
	TerminateThread(hThreadShowClock, 0);
	ExitThread(0);

}

VOID SettingClock(Time* clock)
{
	int flag = 1;
	while (flag)
	{
		puts("    \"::\" (. \"1:2:3\")");
		char* timeString = malloc(S_BUFFER);
		gets_s(timeString, S_BUFFER);
		int resultRead = sscanf(timeString, "%u:%u:%u", &clock->hour, &clock->minute, &clock->second);
		if (resultRead == 0)
		{
			puts(" -   ... ");
			continue;
		}
		if (!(clock->hour < 24 && clock->minute < 60 && clock->second < 60 && clock->hour >= 0 && clock->minute >= 0 && clock->second >= 0))
		{
			puts("   ,     0  23,      0  59.\n");
			continue;
		}
		flag = 0;
	}
	return 0;
}

DWORD WINAPI WorkTimer(LPVOID param)
{
	/*char* stringTime = malloc(sizeof(char) * 9);
	sprintf(stringTime, "\t: %02d:%02d:%02d\0", timer->hour, timer->minute, timer->second);
	puts(stringTime);*/
	if (idShowThread != 0)
	{
		TerminateProcess(hThreadShow, 0);
	}
	Time* timer = (Time*)param;
	if (timer->hour == 0 && timer->minute == 0 && timer->second <= 0)
	{
		puts("\n 00:00:00 -    ? \n");
		ExitThread(0);

	}
	hThreadShow = CreateThread(NULL, 0, thShowTime, timer, NULL, &idShowThread);	
	while (1)
	{
		if (timer->second <= 0)
		{
			if (timer->hour == 0 && timer->minute == 0 && timer->second == 0)
				break;
			timer->second = 59;
			if(timer->minute != 0)
				timer->minute--;
		}
		if (timer->minute == 0 && timer->hour != 0)
		{
			timer->minute = 59;
			if (timer->hour != 0)
				timer->hour--;
		}
		Sleep(1000); //  
		timer->second--;
		
		
	}

	TerminateThread(hThreadShow, 0);
	idShowThread = 0;
	puts("\n-.  \n");
	Pause(hThreadShowClock);
	if (GetCurrentThread == hActivityThread)
		hActivityThread == NULL;
	ExitThread(0);
}

DWORD WINAPI WorkStopwatch(LPVOID param) 
{
	if (idShowThread != 0)
	{
		TerminateProcess(hThreadShow, 0);
	}
	Time* stopwatch = (Time*)param;
	hThreadShow = CreateThread(NULL, 0, thShowTime, stopwatch, NULL, &idShowThread);
	PassTime(stopwatch);
	if (GetCurrentThread == hActivityThread)
		hActivityThread == NULL;
	ExitThread(0);
}

void Pause(HANDLE hThread)
{
	if (hThread == NULL && hThread != hThreadShowClock && hThread != hThreadShow)
	{
		puts("  ,   ?    .");
		return;
	}
	int countPause = SuspendThread(hThread);
	if (countPause > 0)
	{
		//puts(" .");
		while (countPause != 0)
		{
			countPause = ResumeThread(hThread);
		}
		return;
	}
	if(hThread != hThreadShowClock && hThread != hThreadShow)
		puts(" .   ,    5.");
}