#include "Header.h"

typedef void(*message)(); //   
typedef void(*func)();


struct FunctionInList
{
	func function;
	struct FunctionInList* nextFunc;
};

typedef struct FunctionInList FunctionInList;
typedef FunctionInList* ListOfFunctions;

/// <summary>
///  .
/// </summary>
/// <param name="function">func ,   .</param>
/// <returns>  .</returns>
ListOfFunctions createListOfFunctions(func function)
{
	ListOfFunctions head = malloc(sizeof(ListOfFunctions));
	head->function = function;
	head->nextFunc = NULL;
	return head;
}

/// <summary>
///     .
/// </summary>
/// <param name="list">  .</param>
/// <param name="addedFunction"> .</param>
void addFunctionToList(ListOfFunctions list, func addedFunction)
{
	while (list->nextFunc)
	{
		list = list->nextFunc;
	}
	ListOfFunctions newElement = malloc(sizeof(ListOfFunctions));
	newElement->function = addedFunction;
	newElement->nextFunc = NULL;
	list->nextFunc = newElement;
}

void printListOfFunction(ListOfFunctions list)
{
	while (list)
	{
		list->function();
		list = list->nextFunc;
	}
}



/// <summary>
///     .
/// </summary>
/// <param name="list">  .</param>
/// <param name="removedFunction">   .</param>
/// <returns>    .</returns>
ListOfFunctions removeFirstFunctionFromList(ListOfFunctions list, func removedFunction)
{
	//    ,      
	//    ,    
	ListOfFunctions head = malloc(sizeof(ListOfFunctions));
	//ListOfFunctions currentElement = head;
	if (list->function == removedFunction)
	{
		head = list->nextFunc;
		//free(list); //  
		return head;
	}
	head = list;
	while (list->nextFunc)
	{
		if (list->nextFunc->function == removedFunction)
		{
			list->nextFunc = list->nextFunc->nextFunc;
			break;
		}
		list = list->nextFunc;
	}
	return head;
}

/// <summary>
///    ,    .   .
/// </summary>
/// <param name="list"> .</param>
/// <returns> .</returns>
//ListOfFunctions removeDuplicateFunctionFromList(ListOfFunctions list)
//{
//	ListOfFunctions newList = createListOfFunctions(list->function);
//	
//	while (list->nextFunc)
//	{
//		list = list->nextFunc;
//		int haveFunction = 1;
//		ListOfFunctions newCurrentItem = newList;
//		while (newCurrentItem->nextFunc)
//		{
//			if (newCurrentItem->function == list->function)
//			{
//				haveFunction = 0;
//			}
//			newCurrentItem = newCurrentItem->nextFunc;
//		}
//		if (haveFunction)
//		{
//			newCurrentItem->nextFunc = createListOfFunctions(list->function);
//		}
//	}
//	return newList;
//}

/// <summary>
///    .
/// </summary>
/// <param name="list"> .</param>
/// <returns>ListOfFunctions list   .</returns>
ListOfFunctions removeDuplicateFromDelegate(ListOfFunctions list)
{
	ListOfFunctions head = list;
	ListOfFunctions currentFunction = list;
	while (list->nextFunc)
	{
		ListOfFunctions currentFunction = list->nextFunc;
		list = head;
		while (list->nextFunc)
		{
			if (list == currentFunction)
			{
				break;
			}
			if (list->function == currentFunction->function && list != currentFunction)
			{
				while (list->nextFunc != currentFunction)
				{
					list = list->nextFunc;
				}
				list->nextFunc = currentFunction->nextFunc;
				break;
			}
			list = list->nextFunc;
		}
	}
	return head;
}

void firstMes()
{
	printf(" \n");
}
void secondMes()
{
	printf(" \n");
}
void thirdMes()
{
	printf(" \n");
}

int startWorkWithDelegate()
{
	//system("chcp 1251>nul");
	//     ,       ...
		/*message* mes = calloc(2, sizeof(void*));
		mes[0] = secondMes;
		mes[0]();
		mes[1] = firstMes;
		mes[1]();
		mes = realloc(mes, (sizeof(void*) * 1));
		mes[0]();*/


		//   
	ListOfFunctions myList = createListOfFunctions(firstMes);
	addFunctionToList(myList, secondMes);
	addFunctionToList(myList, firstMes);
	addFunctionToList(myList, thirdMes);
	addFunctionToList(myList, secondMes);
	printListOfFunction(myList);

	myList = removeFirstFunctionFromList(myList, firstMes);
	printf("\n        \n");
	printListOfFunction(myList);

	printf("\n    \n");
	myList = removeDuplicateFromDelegate(myList);
	printListOfFunction(myList);

	return 0;
}
