#include "TaskHeader.h"

#define pow2(count) (count * count)

/// <summary>
///   .
/// </summary>
/// <param name="x1">   .</param>
/// <param name="y1">   .</param>
/// <param name="x2">   .</param>
/// <param name="y2">   .</param>
/// <returns></returns>
float lenghtLineSegment(float x1, float y1, float x2, float y2)
{
	return sqrtf(pow2((x2 - x1)) + pow2((y2 - y1)));
}

int itsTriangle(float lenghtFirstSide, float lenghtSecondSide, float lenghtThirdSide)
{
	int triangle = 1;
	float sumFirstSecond = lenghtFirstSide + lenghtSecondSide;
	float sumFirstThird = lenghtFirstSide + lenghtThirdSide;
	float sumThirdSecond = lenghtThirdSide + lenghtFirstSide;
	if (sumFirstSecond <= lenghtThirdSide || sumFirstThird <= lenghtSecondSide || sumThirdSecond <= lenghtFirstSide)
	{
		triangle = 0;
	}
	return triangle;
}

float perimetrTriangle(float lenghtFirstSide, float lenghtSecondSide, float lenghtThirdSide)
{
	return lenghtFirstSide + lenghtSecondSide + lenghtThirdSide;
}

float squareTriangle(float lenghtFirstSide, float lenghtSecondSide, float lenghtThirdSide)
{
	float halfPerimetr = perimetrTriangle(lenghtFirstSide, lenghtSecondSide, lenghtThirdSide) / 2.0;
	return sqrtf(halfPerimetr * (halfPerimetr - lenghtFirstSide) * (halfPerimetr - lenghtSecondSide) * (halfPerimetr - lenghtThirdSide));
}

void infoAboutTriangle(float x1, float y1, float x2, float y2, float x3, float y3)
{
	printf("\n \n");

	float a = lenghtLineSegment(x1, y1, x2, y2);
	float b = lenghtLineSegment(x1, y1, x3, y3);
	float c = lenghtLineSegment(x3, y3, x2, y2);

	printf(" = %f\n", a);
	printf("b = %f\n", b);
	printf("c = %f\n", c);

	if (itsTriangle(a, b, c))
	{
		printf(" \n");
		float perimetr = perimetrTriangle(a, b, c);
		float square = squareTriangle(a, b, c);
		printf(" %f\n", perimetr);
		printf(" %f\n", square);
	}
	else
		printf("  \n");
}

void infoAboutTriangleWithDirective()
{
	printf("\n   #if, #else, #elif, #endif.\n");
#define X1 1
#define Y1 1
#define X2 2
#define Y2 2
#define X3 3
#define Y3 3

#if ((X2-X1)/(Y2-Y1) == (X3 - X1)/(Y3 - Y1))
	printf("  .\n");
	return;

#else
	#define SQUARE ((X2 - X1) * (Y3-Y1) - (X3-X1)*(Y2-Y1))/2

	float a = lenghtLineSegment(X1, Y1, X2, Y2);
	float b = lenghtLineSegment(X1, Y1, X3, Y3);
	float c = lenghtLineSegment(X3, Y3, X2, Y2);

	printf(" = %f\n", a);
	printf("b = %f\n", b);
	printf("c = %f\n", c);

	float perimetr = perimetrTriangle(a, b, c);
	printf(" %f\n", perimetr);

	#if (SQUARE < 0)

	
		#define MODULE_SQUARE ((X2 - X1) * (Y3-Y1) - (X3-X1)*(Y2-Y1))/-2
			printf("  = %d\n", MODULE_SQUARE);

		#elif(SQUARE > 0)
			printf("  = %d\n", SQUARE);

	#endif
#endif
}


#define FIRST_F 5.0
#define SECOND_F 2.5
#define INT_COUNT 125
#define STRING_COUNT "425"

int startWorkWithDerective()
{
	//system("chcp 1251>nul");
	printf("%f %f %f %f\n", sum(FIRST_F, SECOND_F), subtrct(FIRST_F, SECOND_F), divsn(FIRST_F, SECOND_F), multipl(FIRST_F, SECOND_F));
	char* s1 = calloc(3, sizeof(char));
	char* s2 = calloc(3, sizeof(char));
	for (size_t i = 0; i < 2; i++)
	{
		s1[i] = 'a';
		s2[i] = 'b';
	}
	printf("%s\n", stringConcatenation(s1, s2));

	printf("%s\n", countInString(INT_COUNT));
	printf("%d\n", stringInCount(STRING_COUNT));
	printf("%d\n", pow2(2));
	printf("%f\n", pow2(2.5));

	infoAboutTriangle(1, 1, 2, 2, 3, 3);
	infoAboutTriangleWithDirective();

	return 0;
}