#include "QuadEq.h"
#include <math.h>


void solutionQuadraticEquation(QuadraticEquation* equation)
{

	equation->discriminant = equation->b * equation->b - 4 * equation->a * equation->c;
	if (equation->discriminant < 0)
	{
		equation->countRoot = 0;
		return;
	}
	if (equation->discriminant == 0)
	{
		equation->x1 = (-(equation->b) / (2 * equation->a));
		equation->countRoot = 1;
		return;
	}
	if (equation->discriminant > 0)
	{
		equation->x1 = (-equation->b + sqrtf(equation->discriminant)) / (2 * equation->a);
		equation->x2 = (-equation->b - sqrtf(equation->discriminant)) / (2 * equation->a);
		equation->countRoot = 2;
		return;
	}

}